# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ResourcesManagement::Mgmt::V2018_03_01_preview
  module Models
    #
    # The entity.
    #
    class EntityInfo

      include MsRestAzure

      # @return [String] The fully qualified ID for the entity.  For example,
      # /providers/Microsoft.Management/managementGroups/0000000-0000-0000-0000-000000000000
      attr_accessor :id

      # @return [String] The type of the resource. For example,
      # /providers/Microsoft.Management/managementGroups
      attr_accessor :type

      # @return [String] The name of the entity. For example,
      # 00000000-0000-0000-0000-000000000000
      attr_accessor :name

      # @return [String] The AAD Tenant ID associated with the entity. For
      # example, 00000000-0000-0000-0000-000000000000
      attr_accessor :tenant_id

      # @return [String] The friendly name of the management group.
      attr_accessor :display_name

      # @return [EntityParentGroupInfo] Parent.
      attr_accessor :parent

      # @return [Enum] Permissions. Possible values include: 'noaccess',
      # 'view', 'edit', 'delete'
      attr_accessor :permissions

      # @return [Enum] Inherited Permissions. Possible values include:
      # 'noaccess', 'view', 'edit', 'delete'
      attr_accessor :inherited_permissions

      # @return [Integer] Number of Descendants.
      attr_accessor :number_of_descendants

      # @return [Integer] Number of Children. Number of children is the number
      # of Groups and Subscriptions that are exactly one level underneath the
      # current Group.
      attr_accessor :number_of_children

      # @return [Integer] Number of Child Groups. Number of child groups is the
      # number of Groups that are exactly one level underneath the current
      # Group.
      attr_accessor :number_of_child_groups

      # @return [Array<String>] The parent display name chain from the root
      # group to the immediate parent
      attr_accessor :parent_display_name_chain

      # @return [Array<String>] The parent name chain from the root group to
      # the immediate parent
      attr_accessor :parent_name_chain


      #
      # Mapper for EntityInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EntityInfo',
          type: {
            name: 'Composite',
            class_name: 'EntityInfo',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tenantId',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              parent: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.parent',
                type: {
                  name: 'Composite',
                  class_name: 'EntityParentGroupInfo'
                }
              },
              permissions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.permissions',
                type: {
                  name: 'String'
                }
              },
              inherited_permissions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.inheritedPermissions',
                type: {
                  name: 'String'
                }
              },
              number_of_descendants: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.numberOfDescendants',
                type: {
                  name: 'Number'
                }
              },
              number_of_children: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.numberOfChildren',
                type: {
                  name: 'Number'
                }
              },
              number_of_child_groups: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.numberOfChildGroups',
                type: {
                  name: 'Number'
                }
              },
              parent_display_name_chain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.parentDisplayNameChain',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              parent_name_chain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.parentNameChain',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
